"use strict";
this.name        = "hudselector";
this.author      = "Norby";
this.copyright   = "2014 Norby";
this.description = "Change your HUD during flight between the supported ones.";
this.licence     = "CC BY-NC-SA 4.0";

this.$HUDSelectorHUDs = [["Default HUD","hud"], //name and .plists
			//original is a copy of the oolite's stock hud.plist but with more MFDs
			["Original HUD with 10 MFDs and custom dials","hudselector-original"],
			 //copy of stock hud-small.plist but with more MFDs
			["Small HUD with 10 MFDs and custom dials","hudselector-small"]
			];
this.$HUDSelectorOldHUDs = [["Default HUD","hud"], //without custom dials for Oolite 1.80 and below
			["Original HUD with 10 MFDs","hudselector-oldoriginal"],
			["Small HUD with 10 MFDs","hudselector-oldsmall"]
			];

//default MFD 1-10 worldScript names
this.$HUDSelectorMFDs = [["combat_MFD"],
			["telescope"],
			["CommsLogMFD"],
			["BroadcastCommsMFD"],
			["trophy_col", "trophy_mfd"], //mfd name is different
			["navi_mfd"],
			["market_inquirer", "inquirer_mfd"], //mfd name is not equal with worldScript name
			["manifest_mfd"],
			["useful_MFDs", "useful_MFD_general_info"] //mfd name is different
			];

this.$HUDSelectorScanSet = ["Linear, NormalZoom",
			"NonLinear, NormalZoom",
			"Linear, UltraZoom",
			"NonLinear, UltraZoom"];

//internal properties, should not touch
this.$combatWS = null; //pointer to the worldScript of CombatMFD
this.$HUDSelectorDefaultMFDs = []; //load the default MFD settings into this array
this.$HUDSelectorDialNo = 0; //where will start the Dial Interface
this.$HUDSelectorChoice = null; //store the last selection in missionscreens
this.$HUDSelectorEqSel = 0; //number of the selected HUD
this.$HUDSelectorFix = true; //turn on the fix of scanner settings problem caused by Auto Crosshairs OXP
this.$HUDSelectorFixInEveryFrame = false; //needed if both Auto Crosshairs OXP and Telescope OXP is installed
this.$HUDSelectorFixFCB = null; //FCB for fixing crosshairs change bug
this.$HUDSelectorFCB = null; //FCB for missionscreen choices
this.$HUDSelectorFCB2 = null; //another FCB for MFD missionscreen choices
this.$HUDSelectorFCB3 = null; //another FCB for Dial missionscreen choices
this.$HUDSelectorScanner = 0; //store the combined number of NonLinear and UltraZoom scanner settings
this.$HUDSelectorTimer = null; //store a 0.1s delay timer for other startUps
this.$C = -1; //store the last crosshairs setting for FixFCB
this.$H = -1; //store the last hud setting for FixFCB
this.$L = -1; //store the last scanner linearity setting for FixFCB
this.$Z = -1; //store the last scanner zoom setting for FixFCB


//equipment events
this.activated = function() {
	var h = worldScripts.hudselector;
	h.$HUDSelectorEqSel++; //select next HUD
	if( h.$HUDSelectorEqSel >= h.$HUDSelectorHUDs.length ) h.$HUDSelectorEqSel = 0;
	player.consoleMessage( h.$HUDSelectorHUDs[h.$HUDSelectorEqSel][0]+" selected", 10 );
	h.$HUDSelectorSetHUD(h);
}

this.mode = function() {
	var h = worldScripts.hudselector;
	var b = 0;
	if( player.ship.scannerNonLinear ) b += 1;
	if( player.ship.scannerUltraZoom ) b += 2;
	b++;
	if( b > 3 ) b = 0;
	player.consoleMessage( "Scanner: " + h.$HUDSelectorScanSet[b], 10 );
	this.$HUDSelectorSetScanner(b);
}

//worldscript events
this.startUp = function() {
	this.$combatWS = worldScripts.combat_MFD;
	var s = missionVariables.$HUDSelectorDataShow;
	if( this.$combatWS && this.$combatWS.$DataShow && s ) {
		var d = JSON.parse( s );
//		log(this.name, d);//debug
		for( key in d ) {
			this.$combatWS.$DataShow[key] = d[key];
//			log(this.name, key+"="+d[key]);//debug
		}
		//do not use this.$combatWS.$DataShow=d; to avoid cropping DataShow array
	}	//in the case of a new CombatMFD with longer array and loading an old savegame

//	player.ship.setCustomHUDDial("combatLight",[0.0,0.5,1.0,1.0]);	//debug
	this.$MFDsetup = true; //do once only after load game
	
	if( !player.ship.setCustomHUDDial ) {//for Oolite 1.80 and below
		//this.$HUDSelectorHUDs = this.$HUDSelectorOldHUDs; - do not use, overwrite external additions
		this.$HUDSelectorHUDs[1] = this.$HUDSelectorOldHUDs[1]; //oldoriginal
		this.$HUDSelectorHUDs[2] = this.$HUDSelectorOldHUDs[2]; //oldsmall
	}
	
	this.$HUDSelectorScanner = missionVariables.$HUDSelectorScanner;
	var d = missionVariables.$HUDSelectorDefaultMFDs;
	if( !d ) this.$HUDSelectorDefaultMFDs = [];
	else if( (d+"").indexOf(",") ) this.$HUDSelectorDefaultMFDs = (d+"").split(","); //need +"" for bugfix of a single item
	else this.$HUDSelectorDefaultMFDs = [d];
//	log(this.name, "DefaultMFDs: "+this.$HUDSelectorDefaultMFDs);//debug
	
	this.$HUDSelectorEqSel = 0; //number of the selected HUD
	this.$HUDSelectorTimer = new Timer(this, this.$HUDSelectorRestoreHUD.bind(this), 0.1, 0); //0.1s delay for other startUps

	if( player.ship && player.ship.docked ) this.shipDockedWithStation( player.ship.dockedStation ); //set interface
	else if( system ) this.shipDockedWithStation( system.mainStation );//fallback

	if( worldScripts["Auto Crosshairs"] && worldScripts.telescope )
		this.$HUDSelectorFixInEveryFrame = true; //needed if both Auto Crosshairs OXP and Telescope OXP is installed

	if(this.$HUDSelectorFix) //FCB for fixing crosshairs change bug
		this.$HUDSelectorFixFCB = addFrameCallback( this.$HUDSelector_FixFCB.bind(this) );
}

this.startUpComplete = function() {
	if( !this.$HUDSelectorDefaultMFDs || !(this.$HUDSelectorDefaultMFDs.length > 0) ) {
		//set default MFDs first time in order of $HUDSelectorMFDs array
		this.$HUDSelectorDefaultMFDs = [];
		for(var i = 0; i < this.$HUDSelectorMFDs.length; i++) {
			if(this.$HUDSelectorMFDs[i] && this.$HUDSelectorMFDs[i][0]) {
				var w = this.$HUDSelectorMFDs[i][0]; //worldScript name
				if( worldScripts[w] ) {
					this.$HUDSelectorDefaultMFDs[i] = w;
				}
			}
		}
	}
//	log(this.name, "DefaultMFDs: "+this.$HUDSelectorDefaultMFDs);//debug
	log(this.name, "HUDs: "+this.$HUDSelectorHUDs);//debug

//	for(var i=1;i<50;i++) this.$HUDSelectorAddHUD("Your HUD"+i, this.name+i); //debug
}

this.playerBoughtEquipment = function(equipmentKey) {
	if( equipmentKey == "EQ_HUDSELECTOR_REMOVE" ) {
		var eq = equipmentKey.substr( 0, equipmentKey.length-7 );//the real eq
		player.ship.removeEquipment( eq ); //remove it
		player.ship.removeEquipment( equipmentKey ); //remove the "bought" remove eq
	}
}

this.playerWillSaveGame = function(message) {
	missionVariables.$HUDSelectorHUD = this.$HUDSelectorHUDs[this.$HUDSelectorEqSel][1];
	missionVariables.$HUDSelectorDefaultMFDs = this.$HUDSelectorDefaultMFDs;  //store default MFDs
	missionVariables.$HUDSelectorScanner = this.$HUDSelectorScanner;
	if(this.$combatWS && this.$combatWS.$DataShow )
		missionVariables.$HUDSelectorDataShow = JSON.stringify(this.$combatWS.$DataShow);
}

this.shipLaunchedFromStation = function() {
	var h = worldScripts.hudselector;
	h.$HUDSelectorSetScanner(h.$HUDSelectorScanner); //restore the scanner linear and zoom settings
}

this.shipTargetAcquired = this.shipTargetLost = function() {
	//Must fix after each target loss due to Auto Crosshairs OXP break the scanner settings
	if(worldScripts["Auto Crosshairs"]) this.$C = -1;
}

this.shipWillDockWithStation = function(station)
{
	var l = player.ship.multiFunctionDisplayList;
	if( l ) { //from Oolite 1.81
//		log(this.name, "MFDList: "+l);//debug
		worldScripts.hudselector.$HUDSelectorDefaultMFDs = l; //save in-flight changes
	}
}

this.shipDockedWithStation = function(station)
{
	this.$HUDSelectorDialNo = 0;
	station.setInterface("HUD and MFD selector",{
		title: "HUD and MFD selector",
		category: "Ship Systems",
		summary: "Select your HUD and the default Multi-Function Displays.",
		callback: this.$HUDSelector_Interface.bind(this)
		});
}

this.shipWillLaunchFromStation = function() {
//	log(this.name, "MFDSetup: "+this.$MFDsetup);//debug
//	log(this.name, "DefaultMFDs: "+this.$HUDSelectorDefaultMFDs);//debug
	if(this.$MFDsetup) { //must setup MFDs here and not eralier in startup()
		this.$MFDsetup = false; //do only once after load game or MFD interface
		this.$HUDSelectorSetMFDs(this);
	}
}

//HUDSelector methods
this.$HUDSelectorAddHUD = function(hudname, hudplist) {
	worldScripts.hudselector.$HUDSelectorHUDs.push([hudname, hudplist]);
}

this.$HUDSelectorAddMFD = function(mfdworldscript, mfdname) {
	if(!mfdworldscript) return; //this one is really needed
	if(!mfdname) mfdname = mfdworldscript; //if the mfd name is missing then assume than equal with wsname

	var h = worldScripts.hudselector;
	var mfdin = false;
	for(var i = 0; i < h.$HUDSelectorMFDs.length; i++) {
		if(h.$HUDSelectorMFDs[i] && mfdworldscript == h.$HUDSelectorMFDs[i][0])
			mfdin = true;
	}
	if(!mfdin) h.$HUDSelectorMFDs.push([mfdworldscript, mfdname]);
}

this.$HUDSelectorRestoreHUD = function() { //call after all startUp finished where other worldScripts can add HUDs
	var h = worldScripts.hudselector;
	var hud = missionVariables.$HUDSelectorHUD; //restore saved HUD
	if( hud && hud.length > 0 ) {
		for( var i = 0; i < h.$HUDSelectorHUDs.length; i++ ) {
			if( h.$HUDSelectorHUDs[i][1] == hud ) {
				h.$HUDSelectorEqSel = i;
				h.$HUDSelectorSetHUD(h);
			}
		}
	}
}

this.$HUDSelectorSetHUD = function(h) {
	var p = h.$HUDSelectorHUDs[h.$HUDSelectorEqSel][1];
	player.ship.hud =  p+".plist"; //set the selected HUD
	h.$HUDSelectorSetScanner(h.$HUDSelectorScanner); //restore the scanner linear and zoom settings

	for( var i = 0; i < h.$HUDSelectorHUDs.length; i++ ) { //call callback functions
		var off = true; //deactivate all HUDs
		if( i == h.$HUDSelectorEqSel ) off = false; //activate the selected one
		var wh = worldScripts[h.$HUDSelectorHUDs[i][1]];
		if( wh && wh.$HUDSelectorCallBack ) wh.$HUDSelectorCallBack( off );
		//if( wh ) wh += wh.$HUDSelectorCallBack; //debug
		//log("hudselector",i+". "+p+" "+wh); //debug
	}
	h.$HUDSelectorSetMFDs(h);
}

this.$HUDSelectorSetMFDs = function(h) {
	for(var i = 0; i < h.$HUDSelectorDefaultMFDs.length; i++) {
//	log(h.name, i+". MFD: "+h.$HUDSelectorDefaultMFDs[i]);//debug
		if(h.$HUDSelectorDefaultMFDs[i]) {
			var w = h.$HUDSelectorDefaultMFDs[i]; //worldScript or MFD name
			var mfd = -1;
			if( w && w.length > 0 && w != "undefined" ) {
				for(var j = 0; j < h.$HUDSelectorMFDs.length; j++) {
					if( h.$HUDSelectorMFDs[j][0] == w
						|| h.$HUDSelectorMFDs[j][1] == w ) mfd = j;
				}
			}
			var m = null;
			if( mfd > -1) m = h.$HUDSelectorMFDs[mfd][1]; //MFD name
			if( !m ) m = w; //mfd name is equal with worldScript name
			if( m && worldScripts[w] && w != "undefined" )
				player.ship.setMultiFunctionDisplay(i, m);
			else if( w && w.length > 0 ) player.ship.setMultiFunctionDisplay(i, w);
			else player.ship.setMultiFunctionDisplay(i, "");
//			log(h.name, i+". MFD: "+w+" "+m+" "+worldScripts[w]);//debug
		}
	}
}

this.$HUDSelectorSetScanner = function(b) {
	if( b == 1 || b == 3 ) player.ship.scannerNonLinear = true;
	else player.ship.scannerNonLinear = false;
	if( b == 2 || b == 3 ) player.ship.scannerUltraZoom = true;
	else player.ship.scannerUltraZoom = false;
	worldScripts.hudselector.$HUDSelectorScanner = b;
}

this.$HUDSelector_FixFCB = function( delta ) { //FrameCallBack for fixing crosshairs change bug
	if( player && player.ship ) {
		
//		var s = player.ship.speed/player.ship.maxSpeed;//debug
//		player.ship.setCustomHUDDial("HUDIndicator", 2*s-1);//debug
//		player.ship.setCustomHUDDial("HUDLight",[s,0.5,1.0,s]);//debug
		
		var h = worldScripts.hudselector;
		//detect crosshairs change made by Auto Crosshairs OXP
		if( h.$C != player.ship.crosshairs && h.$HUDSelectorFix ) { //can be disabled by this variable
//			if(h.$C == -1) log(h.name, "Target acquired or lost, fixing scanner settings");
//			else log(h.name, "Crosshairs changed to "+player.ship.crosshairs+", fixing scanner settings");
			h.$C = player.ship.crosshairs;
			h.$HUDSelectorSetScanner(h.$HUDSelectorScanner); //fix scanner settings cleared by crosshairs change
		}
		if( h.$H != player.ship.hud && h.$HUDSelectorFix ) { //can be disabled by this variable
			h.$H = player.ship.hud; //a scripted hud changed the actual plist and reverted back the scanner settings
			h.$HUDSelectorSetScanner(h.$HUDSelectorScanner); //fix scanner settings cleared by crosshairs change
		}
		var l = player.ship.scannerNonLinear;
		var z = player.ship.scannerUltraZoom;
		if( h.$L != l || h.$Z != z ) { //log scanner settings changes and crosshair problems
			h.$L = l;
			h.$Z = z;
			if( h.$HUDSelectorFixInEveryFrame ) h.$HUDSelectorSetScanner(h.$HUDSelectorScanner);
			else log(h.name, "Scanner NonLinear:"+l+" UltraZoom:"+z
				+" HUD:"+player.ship.hud+" Crosshairs: "+player.ship.crosshairs
				+", scanner settings is not fixed.");
		}
	}
}

this.$HUDSelector_FCB = function( delta ) { //FrameCallBack for interface screen
	var h = worldScripts.hudselector;
	if( isValidFrameCallback( h.$HUDSelectorFCB ) ) removeFrameCallback( h.$HUDSelectorFCB );
	h.$HUDSelector_Interface();
}

this.$HUDSelector_FCB2 = function( delta ) { //FrameCallBack for interface screen
	var h = worldScripts.hudselector;
	if( isValidFrameCallback( h.$HUDSelectorFCB2 ) ) removeFrameCallback( h.$HUDSelectorFCB2 );
	h.$HUDSelector_InterfaceMFD();
}

this.$HUDSelector_FCB3 = function( delta ) { //FrameCallBack for interface screen
	var h = worldScripts.hudselector;
	if( isValidFrameCallback( h.$HUDSelectorFCB3 ) ) removeFrameCallback( h.$HUDSelectorFCB3 );
	h.$HUDSelector_InterfaceDial();
}

this.$HUDSelector_Interface = function() {
	var h = worldScripts.hudselector;
	player.ship.hudHidden = false;
	h.$HUDSelectorSetHUD(h);
	var c = [];
	var title = "HUD selector";
	var len = h.$HUDSelectorHUDs.length;
	var maxc = 18; //max.22 lines in total with mfd, custom dials, more and exit
	var more = null;
	if( len > maxc ) more = "More";
	var dialno = h.$HUDSelectorDialNo;
	if( dialno >=  len ) dialno = h.$HUDSelectorDialNo = 0; //go back to the start
	for( var j = dialno; j < dialno+maxc && j < len; j++ )
		c[ j ] = (j+1)+". "+h.$HUDSelectorHUDs[j][0];
	var cds = "Custom dials setup";
	if( !player.ship.setCustomHUDDial ) cds += " (need Oolite 1.81)";
	if( !this.$combatWS || !this.$combatWS.$DataArray ) cds += " (need CombatMFD 1.8)";
	var ch = {
		"_0" : "MFD setup",
		"_00" : cds,
		"_10" : c[dialno],
		"_11" : c[dialno+1],
		"_12" : c[dialno+2],
		"_13" : c[dialno+3],
		"_14" : c[dialno+4],
		"_15" : c[dialno+5],
		"_16" : c[dialno+6],
		"_17" : c[dialno+7],
		"_18" : c[dialno+8],
		"_19" : c[dialno+9],
		"_20" : c[dialno+10],
		"_21" : c[dialno+11],
		"_22" : c[dialno+12],
		"_23" : c[dialno+13],
		"_24" : c[dialno+14],
		"_25" : c[dialno+15],
		"_26" : c[dialno+16],
		"_27" : c[dialno+17],
		"_M" : more,
		"_ME" : "Exit",
	};
	var ic = "_M";
	if( h.$HUDSelectorEqSel >= dialno && h.$HUDSelectorEqSel < dialno+maxc )
		ic = "_"+(10+h.$HUDSelectorEqSel-dialno);
	mission.runScreen({
		title: title,
		message: "",
//		background: "hudselector_bg.png",
//		model: "["+bgkey+"]",
		spinModel:false,
		initialChoicesKey: ic,
		choices: ch
	},function( choice ) {
		h.$HUDSelectorChoice = choice;
		if( choice == "_ME" ) {
			h.$HUDSelectorDialNo = 0; //start in the first page next time
			mission.exitScreen = "GUI_SCREEN_INTERFACES";
			return;
		}
		if( choice == "_0" ) {
			h.$HUDSelectorChoice = null;
			h.$HUDSelectorDialNo = 0;
			h.$HUDSelector_InterfaceMFD();
			h.$HUDSelectorDialNo = 0; //start in the first page next time
			return;
		}
		if( choice == "_00" ) {
			if( !player.ship.setCustomHUDDial ) {
				player.consoleMessage("Custom dials need Oolite 1.81",10);
			} else if( !this.$combatWS || !this.$combatWS.$DataArray ) {
				player.consoleMessage("Custom dials need CombatMFD 1.8",10);
			} else {
				h.$HUDSelectorChoice = null;
				h.$HUDSelectorDialNo = 0;
				h.$HUDSelector_InterfaceDial();
				h.$HUDSelectorDialNo = 0; //start in the first page next time
				return;
			}
		}
		if( choice == "_M" ) {
			h.$HUDSelectorChoice = null;
			h.$HUDSelectorDialNo += maxc;
		} else if( choice != "_00" ) {
			var t = -1;
			if( choice ) t = choice.substr(1) - 10; //cut starting "_"
//   			log(h.name, "MFD choice: "+choice+" "+t);//debug
			if(t >= 0 ) {
				t += h.$HUDSelectorDialNo;
				h.$HUDSelectorEqSel = t;
				h.$HUDSelectorSetHUD(h);
			}
		}
		if( !isValidFrameCallback( h.$HUDSelectorFCB ) )
			h.$HUDSelectorFCB = addFrameCallback( h.$HUDSelector_FCB );
	});
}

this.$HUDSelector_InterfaceMFD = function() {
	var h = worldScripts.hudselector;
	h.$MFDsetup = true;
//	player.ship.hudHidden = true; - cause MarketObserver disappear from F8 screen
	var c = [];
	var title = "Default MFD selector";
	var p = player.ship;
	var len = 40;
	if(p && p.isValid) len = p.multiFunctionDisplays;
	var maxc = 20; //max.22 lines in total with done and exit
	var more = null;
	if( len > maxc ) more = "More";
	var dialno = h.$HUDSelectorDialNo;
	if( dialno >=  len ) dialno = h.$HUDSelectorDialNo = 0; //go back to the start
	for( var j = dialno; j < dialno + maxc && j < len; j++ ) {
		var z = h.$HUDSelectorDefaultMFDs[j];
		if( !z ) z = "undefined";
		c[ j ] = (j+1)+". MFD: "+z;
	}
	var ch = {
		"_10" : c[dialno],
		"_11" : c[dialno+1],
		"_12" : c[dialno+2],
		"_13" : c[dialno+3],
		"_14" : c[dialno+4],
		"_15" : c[dialno+5],
		"_16" : c[dialno+6],
		"_17" : c[dialno+7],
		"_18" : c[dialno+8],
		"_19" : c[dialno+9],
		"_20" : c[dialno+10],
		"_21" : c[dialno+11],
		"_22" : c[dialno+12],
		"_23" : c[dialno+13],
		"_24" : c[dialno+14],
		"_25" : c[dialno+15],
		"_26" : c[dialno+16],
		"_27" : c[dialno+17],
		"_28" : c[dialno+18],
		"_29" : c[dialno+19],
		"_M" : more,
		"_ME" : "Exit",
	};
	var ic = "_M";
	if( h.$HUDSelectorChoice ) ic = h.$HUDSelectorChoice;
	mission.runScreen({
		title: title,
		message: "",
//		background: "hudselector_bg.png",
//		model: "["+bgkey+"]",
		spinModel:false,
		initialChoicesKey: ic,
		choices: ch
	},function( choice ) {
		h.$HUDSelectorChoice = choice;
		if( choice == "_ME" ) {
			mission.exitScreen = "GUI_SCREEN_INTERFACES";
			return;
		}
		if( choice == "_M" ) {
			h.$HUDSelectorChoice = null;
			h.$HUDSelectorDialNo += maxc;
		} else {
			var t = -1;
			if( choice ) t = choice.substr(1) - 10; //cut starting "_"
//			log(h.name, "MFD choice: "+choice+" "+t);//debug
			if(t >= 0 ) {
				t += h.$HUDSelectorDialNo;
				var m = h.$HUDSelectorDefaultMFDs[t];
				var mfd = 0;
				if( m && m.length > 0 && m != "undefined" ) {
					for(var i = 0; i < h.$HUDSelectorMFDs.length; i++) {
						if( h.$HUDSelectorMFDs[i] &&
							( m == h.$HUDSelectorMFDs[i][0]
							|| m == h.$HUDSelectorMFDs[i][1] ) )
							mfd = i + 1; //step to the next MFD
					}
				}
				if( mfd >= h.$HUDSelectorMFDs.length )
					h.$HUDSelectorDefaultMFDs[t] = "undefined";
				else {
					var f = h.$HUDSelectorMFDs[mfd][1]; //mfdname
					if( !f ) f = h.$HUDSelectorMFDs[mfd][0]; //worldscriptname
					h.$HUDSelectorDefaultMFDs[t] = f;
				}
			}
		}
		if( !isValidFrameCallback( h.$HUDSelectorFCB2 ) )
			h.$HUDSelectorFCB2 = addFrameCallback( h.$HUDSelector_FCB2 );
	});
}

this.$HUDSelector_InterfaceDial = function() {
	var h = worldScripts.hudselector;
//	player.ship.hudHidden = true; - cause MarketObserver disappear from F8 screen
	var c = [];
	var title = "Custom dials setup";
	var len = h.$combatWS.$DataArray.length;
	var maxc = 20;//max.22 lines in total with more and exit
	var more = null;
	if( len > maxc ) more = "More";
	var dialno = h.$HUDSelectorDialNo;
	if( dialno >=  len ) dialno = h.$HUDSelectorDialNo = 0; //go back to the start
//	log(h.name, "dialno:"+dialno);//debug
	for( var j = dialno; j < dialno + maxc && j < len; j++ ) {
		var combatKey = h.$combatWS.$DataArray[j];
//		log(h.name, j+". "+combatKey);//debug
		if( combatKey ) {
			c[ j ] = (j+1)+". "+combatKey+": "+h.$combatWS.$DataShow[combatKey];
		}
	}
	var ch = {
		"_10" : c[dialno],
		"_11" : c[dialno+1],
		"_12" : c[dialno+2],
		"_13" : c[dialno+3],
		"_14" : c[dialno+4],
		"_15" : c[dialno+5],
		"_16" : c[dialno+6],
		"_17" : c[dialno+7],
		"_18" : c[dialno+8],
		"_19" : c[dialno+9],
		"_20" : c[dialno+10],
		"_21" : c[dialno+11],
		"_22" : c[dialno+12],
		"_23" : c[dialno+13],
		"_24" : c[dialno+14],
		"_25" : c[dialno+15],
		"_26" : c[dialno+16],
		"_27" : c[dialno+17],
		"_28" : c[dialno+18],
		"_29" : c[dialno+19],
		"_M" : more,
		"_ME" : "Exit",
	};
	var ic = "_M";
	if( h.$HUDSelectorChoice ) ic = h.$HUDSelectorChoice;
	mission.runScreen({
		title: title,
		message: "",
//		background: "hudselector_bg.png",
//		model: "["+bgkey+"]",
		spinModel:false,
		initialChoicesKey: ic,
		choices: ch
	},function( choice ) {
		h.$HUDSelectorChoice = choice;
		if( choice == "_ME" ) {
			mission.exitScreen = "GUI_SCREEN_INTERFACES";
			return;
		}
		if( choice == "_M" ) {
			h.$HUDSelectorChoice = null;
			h.$HUDSelectorDialNo += maxc;
		} else {
			var t = -1;
			if( choice ) t = choice.substr(1) - 10; //cut starting "_"
//			log(h.name, "MFD choice: "+choice+" "+t);//debug
			if(t >= 0 ) {
				t += h.$HUDSelectorDialNo;
				var combatKey = h.$combatWS.$DataArray[t];
				h.$combatWS.$DataShow[combatKey] = //inverse
					!h.$combatWS.$DataShow[combatKey];
				if(!h.$combatWS.$DataShow[combatKey]) //clear the old content
					player.ship.setCustomHUDDial(combatKey, "");
			}
		}
		if( !isValidFrameCallback( h.$HUDSelectorFCB3 ) )
			h.$HUDSelectorFCB3 = addFrameCallback( h.$HUDSelector_FCB3 );
	});
}
